function im = pla_label(param,im,kk)

sk = (im.skel == im.labs(kk));
be = bskeleton(sk,0,'looseendsaway');
mask = (sk==sk&~sk)*prod(size(im.im))*1000+sk*1.0;
[dummy,indA]=max(gdt(~be,mask)*sk);
seed = be~=be;
seed(indA(1),indA(2))=1;
[dummy,indB]=max(gdt(~seed,mask)*sk);

im.crdA{1} = indA;
im.crdB{1} = indB;
im.mask{1} = bdilation(sk,3);
im.sk{1}   = im.skel;

if ~any(im.sk{1})
  im.sk{1}=[];
end

if sqrt(sum((indA-indB).^2)) < 10
  skA = bpropagation(seed,sk,round(dummy/2),2,1);
  skB = sk & ~skA;

  im.sk{1} = skA;
  im.sk{2} = skB;
  im.mask{1} = bdilation(skA,3);
  im.mask{2} = bdilation(skB,3);
  
  be                    = bskeleton(skA,0,'looseendsaway');
  mask                  = (skA==skA&~skA)*prod(size(im.im))*1000+skA*1.0;
  [dummy,indA]          = max(gdt(~be,mask)*skA);
  seed                  = be~=be;
  seed(indA(1),indA(2)) = 1;
  [dummy,indB]          = max(gdt(~seed,mask)*skA);
  im.crdA{1}            = indA;
  im.crdB{1}            = indB;
  
  be                    = bskeleton(skB,0,'looseendsaway');
  mask                  = (skB==skB&~skB)*prod(size(im.im))*1000+skB*1.0;
  [dummy,indA]          = max(gdt(~be,mask)*skB);
  seed                  = be~=be;
  seed(indA(1),indA(2)) = 1;
  [dummy,indB]          = max(gdt(~seed,mask)*skB);
  im.crdA{2}            = indA;
  im.crdB{2}            = indB;
end


