function data = pla_DNA_visualisation()

% get settings and image locations etc
param = pla_settings;

if ~exist('selection')|isempty(selection)
  selection = 1:size(param.condition,2);
end

fnpsappend = [param.dir.output, 'overviewappend.ps']
%dsfg=df

if exist(fnpsappend)
  delete(fnpsappend)
  fprintf('\r delete %s\n',fnpsappend);
end

for ii = selection
  fprintf('\r read condition  %3d / %3d %s\n',ii,size(param.condition,2),param.condition(ii).name{1});
  
  fnfit = [param.dir.output filesep param.condition(ii).name{1} '_fit.mat'];
  load(fnfit,'msr');
  data{ii}=msr{ii};

  fnfithist = [param.dir.output filesep param.condition(ii).name{1} '_fithist.mat'];
  load(fnfithist,'msrhist');
  datahist{ii} = msrhist{ii};
  
      
  fnlengths = [param.dir.output filesep param.condition(ii).name{1} '_lengths.mat'];
  load(fnlengths,'lengths');
end

out.usesubplots = true;%generate overview
pla_plot(data,datahist,param,out,selection,lengths);

out.usesubplots = false;%generate seperate figures
pla_plot(data,datahist,param,out,selection,lengths);
